def words_from_string(string)
  string.downcase.scan(/[\w']+/)
end

def count_word_frequency(word_list)
  counts = Hash.new(0)

  word_list.each do |word|
    counts[word] += 1
  end

  counts
end

def rare_words(string, number)
  frequencies = count_word_frequency(words_from_string(string))

  sorted_frequencies = frequencies.sort_by { |word, count| count }

  rarest_n = sorted_frequencies.take(number)

  result = {}

  rarest_n.each do |freq|
    result[freq[0]] = freq[1]
  end

  result
end
